/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef PAT_BUF_H
#define PAT_BUF_H	1

#include "pat.h"

typedef struct		s_buf_assocs_data
{
  int			ulen;
  t_assoc		*assocs;
} t_buf_assocs_data;

extern t_pat		buf_pat;
extern t_pat		bufassoc_pat;
extern t_pat		bufuntil_pat;
extern t_pat		bufstruntil_pat;

/* PROTO pat_buf.c */
/* pat_buf.c */
t_status buf_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status buf_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status buf_pat_insert P((void *data, char *buf, int len, char *value));
t_status buf_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status bufassoc_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status bufassoc_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status bufassoc_pat_insert P((void *data, char *buf, int len, char *value));
t_status bufassoc_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status bufassoc_pat_get_choices P((void *data, char *buf, int len, t_vec *vec_str, t_boolean *do_sort_return));
t_status bufuntil_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status bufuntil_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status bufuntil_pat_insert P((void *data, char *buf, int len, char *value));
t_status bufuntil_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status bufstruntil_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status bufstruntil_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status bufstruntil_pat_insert P((void *data, char *buf, int len, char *value));
t_status bufstruntil_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status bufstruntil_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status bufstruntil_pat_set_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *value));
t_status bufstruntil_pat_get_fields P((void *data, t_vec *vec_str));
t_status bufstruntil_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status bufstruntil_pat_get_field_pat P((void *data, t_id *optional_id, char *buf, int len, char *field, t_pat **pat_return, void **data_return));
#endif
